attribute vec4 a_position;
attribute vec2 a_texCoord;

varying vec2 v_texture_coord;
varying vec4 v_light_color;

uniform float u_top;

void main(void)
{
    v_texture_coord = a_texCoord;
	v_texture_coord.y = 1.0 - v_texture_coord.y;
	
	vec4 position = a_position / vec4(256.0, 256.0, 256.0, 1.0);
	float distance = abs(u_top - position.y);
	float lightness = 0.4 - distance / 16.0;
	lightness = max(0.0, lightness);
	v_light_color = vec4(0.3, 0.3, 0.0, 0) * lightness;

    gl_Position = CC_MVPMatrix * position;
}
